<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/net/ip6_routes.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('df/dc2/ip6__routes_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ip6_routes.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../df/dc2/ip6__routes_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#ifndef IP6_ROUTES_HPP_</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#define IP6_ROUTES_HPP_</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d5/d8c/message_8hpp.html">common/message.hpp</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/d02/ip6__address_8hpp.html">net/ip6_address.hpp</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">namespace </span>Ip6 {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">   55</a></span>&#160;<span class="keyword">struct </span><a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">Route</a></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a41e1f9f20d7892732e0fe95778cfbbdc">   57</a></span>&#160;    <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Address</a>       <a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a41e1f9f20d7892732e0fe95778cfbbdc">mPrefix</a>;        </div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a94cc0707ed7e3df481c3ddfe39e69b87">   58</a></span>&#160;    uint8_t       <a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a94cc0707ed7e3df481c3ddfe39e69b87">mPrefixLength</a>;  </div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a71a90d18a2d02d0054ca80331b2d0f23">   59</a></span>&#160;    int8_t        <a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a71a90d18a2d02d0054ca80331b2d0f23">mInterfaceId</a>;   </div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#aeedcf830abb9ffe3f945fcd6ebac7636">   60</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">Route</a> *<a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#aeedcf830abb9ffe3f945fcd6ebac7636">mNext</a>;          </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;};</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="../../db/ddb/classThread_1_1Ip6_1_1Routes.html">   67</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../db/ddb/classThread_1_1Ip6_1_1Routes.html">Routes</a></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;{</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <a class="code" href="../../db/ddb/classThread_1_1Ip6_1_1Routes.html">Routes</a>(<a class="code" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6</a> &amp;aIp6);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Add(<a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">Route</a> &amp;aRoute);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Remove(<a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">Route</a> &amp;aRoute);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    int8_t Lookup(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Address</a> &amp;aSource, <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Address</a> &amp;aDestination);</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <a class="code" href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">Route</a> *mRoutes;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <a class="code" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6</a> &amp;mIp6;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;};</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;}  <span class="comment">// namespace Ip6</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#endif  // NET_IP6_ROUTES_HPP_</span></div><div class="ttc" id="ip6__address_8hpp_html"><div class="ttname"><a href="../../dc/d02/ip6__address_8hpp.html">ip6_address.hpp</a></div><div class="ttdoc">This file includes definitions for IPv6 addresses. </div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1Route_html_a94cc0707ed7e3df481c3ddfe39e69b87"><div class="ttname"><a href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a94cc0707ed7e3df481c3ddfe39e69b87">Thread::Ip6::Route::mPrefixLength</a></div><div class="ttdeci">uint8_t mPrefixLength</div><div class="ttdoc">The IPv6 prefix length. </div><div class="ttdef"><b>Definition:</b> ip6_routes.hpp:58</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1Route_html_aeedcf830abb9ffe3f945fcd6ebac7636"><div class="ttname"><a href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#aeedcf830abb9ffe3f945fcd6ebac7636">Thread::Ip6::Route::mNext</a></div><div class="ttdeci">struct Route * mNext</div><div class="ttdoc">A pointer to the next IPv6 route. </div><div class="ttdef"><b>Definition:</b> ip6_routes.hpp:60</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Ip6_html"><div class="ttname"><a href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Thread::Ip6::Ip6</a></div><div class="ttdoc">This class implements the core IPv6 message processing. </div><div class="ttdef"><b>Definition:</b> ip6.hpp:96</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Routes_html"><div class="ttname"><a href="../../db/ddb/classThread_1_1Ip6_1_1Routes.html">Thread::Ip6::Routes</a></div><div class="ttdoc">This class implements IPv6 route management. </div><div class="ttdef"><b>Definition:</b> ip6_routes.hpp:67</div></div>
<div class="ttc" id="message_8hpp_html"><div class="ttname"><a href="../../d5/d8c/message_8hpp.html">message.hpp</a></div><div class="ttdoc">This file includes definitions for the message buffer pool and message buffers. </div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1Route_html"><div class="ttname"><a href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html">Thread::Ip6::Route</a></div><div class="ttdoc">This structure represents an IPv6 route. </div><div class="ttdef"><b>Definition:</b> ip6_routes.hpp:55</div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1Route_html_a71a90d18a2d02d0054ca80331b2d0f23"><div class="ttname"><a href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a71a90d18a2d02d0054ca80331b2d0f23">Thread::Ip6::Route::mInterfaceId</a></div><div class="ttdeci">int8_t mInterfaceId</div><div class="ttdoc">The interface identifier. </div><div class="ttdef"><b>Definition:</b> ip6_routes.hpp:59</div></div>
<div class="ttc" id="openthread-types_8h_html"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a></div><div class="ttdoc">This file defines the types and structures used in the OpenThread library API. </div></div>
<div class="ttc" id="structThread_1_1Ip6_1_1Route_html_a41e1f9f20d7892732e0fe95778cfbbdc"><div class="ttname"><a href="../../d6/dcb/structThread_1_1Ip6_1_1Route.html#a41e1f9f20d7892732e0fe95778cfbbdc">Thread::Ip6::Route::mPrefix</a></div><div class="ttdeci">Address mPrefix</div><div class="ttdoc">The IPv6 prefix. </div><div class="ttdef"><b>Definition:</b> ip6_routes.hpp:57</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_73cb4d11b06c10448caf49ed02a351c4.html">net</a></li><li class="navelem"><a class="el" href="../../df/dc2/ip6__routes_8hpp.html">ip6_routes.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
